/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
export declare type StoreArgs = {
    admin: web3.PublicKey;
    name: string;
    description: string;
};
export declare class Store implements StoreArgs {
    readonly admin: web3.PublicKey;
    readonly name: string;
    readonly description: string;
    private constructor();
    static fromArgs(args: StoreArgs): Store;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [Store, number];
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey): Promise<Store>;
    static deserialize(buf: Buffer, offset?: number): [Store, number];
    serialize(): [Buffer, number];
    static byteSize(args: StoreArgs): number;
    static getMinimumBalanceForRentExemption(args: StoreArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    pretty(): {
        admin: string;
        name: string;
        description: string;
    };
}
export declare const storeBeet: beet.FixableBeetStruct<Store, StoreArgs & {
    accountDiscriminator: number[];
}>;
