declare type ErrorWithCode = Error & {
    code: number;
};
declare type MaybeErrorWithCode = ErrorWithCode | null | undefined;
export declare class NoValidSignerPresentError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class StringIsTooLongError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class NameIsTooLongError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class DescriptionIsTooLongError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class SupplyIsGtThanAvailableError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class SupplyIsNotProvidedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class DerivedKeyInvalidError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class SellingResourceOwnerInvalidError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class PublicKeyMismatchError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class PiecesInOneWalletIsTooMuchError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class StartDateIsInPastError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class EndDateIsEarlierThanBeginDateError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class IncorrectOwnerError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MarketIsNotStartedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MarketIsEndedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class UserReachBuyLimitError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MathOverflowError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class SupplyIsGtThanMaxSupplyError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MarketDurationIsNotUnlimitedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MarketIsSuspendedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MarketIsImmutableError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MarketInInvalidStateError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class PriceIsZeroError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class FunderIsInvalidError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class PayoutTicketExistsError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidFunderDestinationError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class TreasuryIsNotEmptyError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class SellingResourceInInvalidStateError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MetadataCreatorsIsEmptyError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class UserWalletMustMatchUserTokenAccountError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MetadataShouldBeMutableError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class PrimarySaleIsNotAllowedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class CreatorsIsGtThanAvailableError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class CreatorsIsEmptyError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare function errorFromCode(code: number): MaybeErrorWithCode;
export declare function errorFromName(name: string): MaybeErrorWithCode;
export {};
