import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type InitSellingResourceInstructionArgs = {
    masterEditionBump: number;
    vaultOwnerBump: number;
    maxSupply: beet.COption<beet.bignum>;
};
export declare type InitSellingResourceInstructionAccounts = {
    store: web3.PublicKey;
    admin: web3.PublicKey;
    sellingResource: web3.PublicKey;
    sellingResourceOwner: web3.PublicKey;
    resourceMint: web3.PublicKey;
    masterEdition: web3.PublicKey;
    metadata: web3.PublicKey;
    vault: web3.PublicKey;
    owner: web3.PublicKey;
    resourceToken: web3.PublicKey;
};
export declare function createInitSellingResourceInstruction(accounts: InitSellingResourceInstructionAccounts, args: InitSellingResourceInstructionArgs): web3.TransactionInstruction;
