import * as web3 from '@solana/web3.js';
export declare type WithdrawInstructionArgs = {
    treasuryOwnerBump: number;
    payoutTicketBump: number;
};
export declare type WithdrawInstructionAccounts = {
    market: web3.PublicKey;
    sellingResource: web3.PublicKey;
    metadata: web3.PublicKey;
    treasuryHolder: web3.PublicKey;
    treasuryMint: web3.PublicKey;
    owner: web3.PublicKey;
    destination: web3.PublicKey;
    funder: web3.PublicKey;
    payer: web3.PublicKey;
    payoutTicket: web3.PublicKey;
    clock: web3.PublicKey;
    associatedTokenProgram: web3.PublicKey;
    primaryMetadataCreators?: web3.PublicKey[];
};
export declare function createWithdrawInstruction(accounts: WithdrawInstructionAccounts, args: WithdrawInstructionArgs): web3.TransactionInstruction;
