import * as beet from '@metaplex-foundation/beet';
export declare enum ErrorCode {
    NoValidSignerPresent = 0,
    StringIsTooLong = 1,
    NameIsTooLong = 2,
    DescriptionIsTooLong = 3,
    SupplyIsGtThanAvailable = 4,
    SupplyIsNotProvided = 5,
    DerivedKeyInvalid = 6,
    SellingResourceOwnerInvalid = 7,
    PublicKeyMismatch = 8,
    PiecesInOneWalletIsTooMuch = 9,
    StartDateIsInPast = 10,
    EndDateIsEarlierThanBeginDate = 11,
    IncorrectOwner = 12,
    MarketIsNotStarted = 13,
    MarketIsEnded = 14,
    UserReachBuyLimit = 15,
    MathOverflow = 16,
    SupplyIsGtThanMaxSupply = 17,
    MarketDurationIsNotUnlimited = 18,
    MarketIsSuspended = 19,
    MarketIsImmutable = 20,
    MarketInInvalidState = 21,
    PriceIsZero = 22,
    FunderIsInvalid = 23,
    PayoutTicketExists = 24,
    InvalidFunderDestination = 25,
    TreasuryIsNotEmpty = 26,
    SellingResourceInInvalidState = 27,
    MetadataCreatorsIsEmpty = 28,
    UserWalletMustMatchUserTokenAccount = 29,
    MetadataShouldBeMutable = 30,
    PrimarySaleIsNotAllowed = 31,
    CreatorsIsGtThanAvailable = 32,
    CreatorsIsEmpty = 33,
    MarketOwnerDoesntHaveShares = 34,
    PrimaryMetadataCreatorsNotProvided = 35,
    GatingTokenMissing = 36,
    InvalidOwnerForGatingToken = 37,
    WrongGatingMetadataAccount = 38,
    WrongOwnerInTokenGatingAcc = 39,
    WrongGatingDate = 40,
    CollectionMintMissing = 41,
    WrongCollectionMintKey = 42,
    WrongGatingToken = 43
}
export declare const errorCodeBeet: beet.FixedSizeBeet<ErrorCode, ErrorCode>;
