import test from 'tape';
import { PayerTransactionHandler } from '@metaplex-foundation/amman';
import { Connection, Keypair, PublicKey } from '@solana/web3.js';
import { CreateMarketInstructionArgs } from '../../src/generated/instructions';
declare type CreateMarketParams = {
    test: test.Test;
    transactionHandler: PayerTransactionHandler;
    payer: Keypair;
    connection: Connection;
    store: PublicKey;
    sellingResource: PublicKey;
    treasuryMint: PublicKey;
    collectionMint?: PublicKey;
    params: Omit<CreateMarketInstructionArgs, 'treasuryOwnerBump'>;
};
export declare const createMarket: ({ test, transactionHandler, payer, connection, store, sellingResource, treasuryMint, collectionMint, params, }: CreateMarketParams) => Promise<{
    market: Keypair;
    treasuryHolder: Keypair;
    treasuryOwnerBump: number;
    treasuryOwner: PublicKey;
}>;
export {};
