"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPrerequisites = void 0;
const web3_js_1 = require("@solana/web3.js");
const amman_1 = require("@metaplex-foundation/amman");
const utils_1 = require("../utils");
const createPrerequisites = async () => {
    const payer = web3_js_1.Keypair.generate();
    const connection = new web3_js_1.Connection(utils_1.connectionURL, 'confirmed');
    const transactionHandler = new amman_1.PayerTransactionHandler(connection, payer);
    await (0, amman_1.airdrop)(connection, payer.publicKey, 30);
    return { payer, connection, transactionHandler };
};
exports.createPrerequisites = createPrerequisites;
//# sourceMappingURL=createPrerequisites.js.map