"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStore = void 0;
const amman_1 = require("@metaplex-foundation/amman");
const web3_js_1 = require("@solana/web3.js");
const instructions_1 = require("../../src/generated/instructions");
const utils_1 = require("../utils");
const createStore = async ({ test, transactionHandler, payer, connection, params, }) => {
    const store = web3_js_1.Keypair.generate();
    const instruction = (0, instructions_1.createCreateStoreInstruction)({
        store: store.publicKey,
        admin: payer.publicKey,
    }, params);
    const transaction = await (0, utils_1.createAndSignTransaction)(connection, payer, [instruction], [store]);
    const createStoreRes = await transactionHandler.sendAndConfirmTransaction(transaction, [store], amman_1.defaultSendOptions);
    (0, utils_1.logDebug)(`store: ${store.publicKey}`);
    (0, amman_1.assertConfirmedTransaction)(test, createStoreRes.txConfirmed);
    return store;
};
exports.createStore = createStore;
//# sourceMappingURL=createStore.js.map