"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mintTokenToAccount = void 0;
const web3_js_1 = require("@solana/web3.js");
const spl_token_1 = require("@solana/spl-token");
const amman_1 = require("@metaplex-foundation/amman");
const createMintAccount_1 = require("./createMintAccount");
const transactions_1 = require("../transactions");
const mintTokenToAccount = async ({ connection, payer, transactionHandler, }) => {
    const tx = new web3_js_1.Transaction();
    const { mint, createMintTx } = await createMintAccount_1.CreateMint.createMintAccount(connection, payer);
    tx.add(createMintTx);
    const { tokenAccount: associatedTokenAccount, createTokenTx } = await (0, transactions_1.createTokenAccount)({
        payer,
        mint: mint.publicKey,
        connection,
    });
    tx.add(createTokenTx);
    tx.add((0, spl_token_1.createMintToInstruction)(mint.publicKey, associatedTokenAccount.publicKey, payer, 1));
    await transactionHandler.sendAndConfirmTransaction(tx, [mint, associatedTokenAccount], amman_1.defaultSendOptions);
    return { mint, mintAta: associatedTokenAccount };
};
exports.mintTokenToAccount = mintTokenToAccount;
//# sourceMappingURL=mintTokenToAccount.js.map