"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tape_1 = __importDefault(require("tape"));
const utils_1 = require("./utils");
const actions_1 = require("./actions");
const verifyCollection_1 = require("./actions/verifyCollection");
(0, utils_1.killStuckProcess)();
(0, tape_1.default)('buy: successful purchase for newly minted treasury mint', async () => {
    const { payer, connection, transactionHandler } = await (0, actions_1.createPrerequisites)();
    const { mint: collectionMint, metadata: collectionMetadata, edition: collectionMasterEditionAccount, } = await (0, actions_1.mintNFT)({
        transactionHandler,
        payer,
        connection,
        maxSupply: 0,
    });
    const { metadata: userCollectionMetadata } = await (0, actions_1.mintNFT)({
        transactionHandler,
        payer,
        connection,
        collectionMint: collectionMint.publicKey,
    });
    await (0, verifyCollection_1.verifyCollection)({
        transactionHandler,
        connection,
        payer,
        metadata: userCollectionMetadata,
        collectionAuthority: payer.publicKey,
        collection: collectionMetadata,
        collectionMint: collectionMint.publicKey,
        collectionMasterEditionAccount,
    });
});
//# sourceMappingURL=collection.test.js.map