"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createClaimResourceTransaction = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const web3_js_1 = require("@solana/web3.js");
const instructions_1 = require("../../src/generated/instructions");
const utils_1 = require("../utils");
const createClaimResourceTransaction = async ({ payer, connection, market, treasuryHolder, sellingResource, vault, metadata, destination, vaultOwnerBump, owner, }) => {
    const instruction = (0, instructions_1.createClaimResourceInstruction)({
        market,
        treasuryHolder,
        sellingResource,
        sellingResourceOwner: payer.publicKey,
        vault,
        metadata,
        owner,
        destination,
        tokenMetadataProgram: mpl_token_metadata_1.PROGRAM_ID,
        clock: web3_js_1.SYSVAR_CLOCK_PUBKEY,
    }, {
        vaultOwnerBump,
    });
    const claimResourceTx = await (0, utils_1.createAndSignTransaction)(connection, payer, [instruction], [payer]);
    return claimResourceTx;
};
exports.createClaimResourceTransaction = createClaimResourceTransaction;
//# sourceMappingURL=claimResource.js.map