"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.closeMarket = void 0;
const web3_js_1 = require("@solana/web3.js");
const utils_1 = require("../utils");
const instructions_1 = require("../../src/generated/instructions");
const closeMarket = async ({ payer, connection, market, }) => {
    const instruction = await (0, instructions_1.createCloseMarketInstruction)({
        market: market.publicKey,
        owner: payer.publicKey,
        clock: web3_js_1.SYSVAR_CLOCK_PUBKEY,
    });
    const marketTx = await (0, utils_1.createAndSignTransaction)(connection, payer, [instruction], [payer]);
    return marketTx;
};
exports.closeMarket = closeMarket;
//# sourceMappingURL=closeMarket.js.map