"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSavePrimaryMetadataCreators = void 0;
const src_1 = require("../../src");
const createSavePrimaryMetadataCreators = async ({ payer, metadata, creators, }) => {
    const [primaryMetadataCreators, primaryMetadataCreatorsBump] = await (0, src_1.findPrimaryMetadataCreatorsAddress)(metadata);
    const savePrimaryMetadataCreatorsInstruction = (0, src_1.createSavePrimaryMetadataCreatorsInstruction)({
        admin: payer.publicKey,
        metadata,
        primaryMetadataCreators,
    }, {
        primaryMetadataCreatorsBump,
        creators,
    });
    return { savePrimaryMetadataCreatorsInstruction, primaryMetadataCreators };
};
exports.createSavePrimaryMetadataCreators = createSavePrimaryMetadataCreators;
//# sourceMappingURL=createSavePrimaryMetadataCreators.js.map